AchSnd.MsgFrame = CreateFrame("Frame" , "AchSndMessageFrame", UIParent )
local me = AchSnd.MsgFrame
me:SetFrameStrata("DIALOG")
me:Hide()

local MOBuff = 5 -- Mouse Over Pixel Buffer
local e = 0 -- elapsed time counter
local cdown = 0 -- auto cancel countdown
local fdelay = 0 -- Fade Countdown

local TxtFrmWidthOffset = 8
local TxtFrmTopOffset = -16
local TxtFrmBottomOffset = -82
local TxtFrmMaxLines = 64
local TextFrameMultiInset = 5

local update= 1/10
local Backdrop1={
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 32,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0
	}
}
local Backdrop2={
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background",
	edgeFile="Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 32,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0
	}
}
local TitleRegionBackdrop1 ={
	bgFile='Interface\\FrameGeneral\\UI-Background-Marble' ,
	edgeFile='Interface\\DialogFrame\\UI-DialogBox-Border',
	tile = true,
	insets = {left = 0, right = 0, top = 0, bottom = 0},
	tileSize =  16,
	edgeSize =  16,
}
local TitleRegionBackdrop2 ={
	bgFile='Interface\\FrameGeneral\\UI-Background-Marble' ,
	edgeFile='Interface\\DialogFrame\\UI-DialogBox-Gold-Border',
	tile = true,
	insets = {left = 0, right = 0, top = 0, bottom = 0},
	tileSize =  16,
	edgeSize =  16,
}

	
me:EnableMouse(true)
me:SetPoint("CENTER", UIParent, "CENTER")
me:SetHeight( 125 )
me:SetWidth( 450 )
me:SetBackdrop( Backdrop1 )
me:SetBackdropColor( 128, 128,128, 1)
me:SetBackdropBorderColor( 255, 255, 255, 1)
me:SetMovable(true)
me:SetUserPlaced(true)
me:SetClampedToScreen(true)

AchSnd.ScrollingMessageFrame = CreateFrame( "ScrollingMessageFrame", "AchSndScrollingMessageFrame", me)
local TextFrame = AchSnd.ScrollingMessageFrame
TextFrame.GetTextColor = function() return 1, 1, 1, 1 end
TextFrame:SetPoint("LEFT", me, "Left", TxtFrmWidthOffset)
TextFrame:SetPoint("RIGHT", me, "RIGHT", (-TxtFrmWidthOffset))
TextFrame:SetPoint("TOP", me, "TOP", 0, TxtFrmTopOffset)
TextFrame:SetPoint("BOTTOM", me, "TOP", 0, TxtFrmBottomOffset)
TextFrame:EnableMouse( true )
TextFrame:EnableMouseWheel( true )
TextFrame:SetHyperlinksEnabled(true)
TextFrame:SetJustifyH( "CENTER" )
TextFrame:SetJustifyV( "MIDDLE" )
TextFrame:SetFading( false )
TextFrame:SetMaxLines( 256 )
--TextFrame:SetInsertMode( "TOP" )
TextFrame:SetFontObject("GameFontNormal")
--TextFrame:SetMultilineIndent( TextFrameMultiInset )
TextFrame:Raise()
do
	local multi -- = AchSnd_Settings.Multi 
	local guild -- = #AchSnd.MBox.Mode.guild > 0
	local party -- = #AchSnd.MBox.Mode.party > 0
	local say   -- = #AchSnd.MBox.Mode.say > 0
	local AutoFadeChecked -- = AchSnd.panel.AutoFade:GetChecked()
	local MultiChecked    -- = AchSnd.panel.Multi:GetChecked()
	local test  -- = AchSnd.MBox.Test
	local MsgBoxTimeout   -- = AchSnd.panel.Timeout:GetValue()
	local count -- = #AchSnd.MBox.Mode.guild + #AchSnd.MBox.Mode.party + #AchSnd.MBox.Mode.say
	local MouseOver -- = me:IsMouseOver(MOBuff, -MOBuff, -MOBuff, MOBuff) or me.TitleRegion:IsMouseOver(MOBuff, -MOBuff, -MOBuff, MOBuff)
	local multiShown = false
	local multiBorder = false
	local GratButtonText
	local oldCount
	local firstFrame = false
	
	TextFrame:SetScript("OnHyperlinkClick", function(self, linkData, link, button)
		if button ~= "LeftButton" then
			return
		end
		SetItemRef(link)
		return
	end)

	TextFrame:SetScript("OnMouseWheel", function(self, delta)
		if delta > 0 then -- move list up 
			TextFrame:ScrollUp()
		elseif delta < 0 then -- move list down
			TextFrame:ScrollDown()
		end
		return
	end)

	me:SetScript("OnShow", function(self)
		--Set Frame Positon for future alerts
		if not(AchSnd_SettingsPC.AlertPosSet) and AchSnd_Settings.NewMsgBox then
			TextFrame:Clear()
			TextFrame:AddMessage( "Please move the \"Grats Alert Frame\" to where you would like it and close it to save its position (You can always move it again later by dragging the title box around)" , 1, .752, .156 )
			me.GratsButton:SetText("Click Me!")
			me.CancelButton:SetText("No, Click Me!")
			return
		end
	
		if not(AchSnd_Settings.AutoFade) then
			me:SetAlpha(1)
		end
		
		multi = AchSnd_Settings.Multi 
		test = AchSnd.MBox.Test
		oldCount = -1
		firstFrame = true
		
		AutoFadeChecked = AchSnd.panel.AutoFade:GetChecked()
		MultiChecked = AchSnd.panel.Multi:GetChecked()
		MsgBoxTimeout = 0
		
		if test then
			AutoFadeChecked = AchSnd.panel.AutoFade:GetChecked()
			MultiChecked = AchSnd.panel.Multi:GetChecked()
			MsgBoxTimeout = AchSnd.panel.Timeout:GetValue()
			TextFrame:AddMessage("This is a test. It is only a test.", 1, .752, .156)
			cdown = AchSnd.panel.Timeout:GetValue()
			fdelay = AchSnd.panel.FadeDelay:GetValue()
		else
			cdown = AchSnd_Settings.Timeout
			fdelay = AchSnd_Settings.FadeDelay
		end
		
		me.CancelButton:SetText("Cancel")
	
	end)

	me:SetScript("OnUpdate", function(self, elapsed)
		if not(AchSnd_SettingsPC.AlertPosSet) then
			return
		end

		e = e + elapsed
		if (e < update) and not(firstFrame) then
			return
		end
		
		firstFrame = false
		
		if not(AchSnd_Settings.NewMsgBox) and not( test ) then
			me:Hide()
		end
		
		-- Items to be updated goes here
		
		guild = #AchSnd.MBox.Mode.guild 
		party = #AchSnd.MBox.Mode.party 
		say = #AchSnd.MBox.Mode.say
		
		count = guild + party + say
		MouseOver = me:IsMouseOver(MOBuff, -MOBuff, -MOBuff, MOBuff) or me.TitleRegion:IsMouseOver(MOBuff, -MOBuff, -MOBuff, MOBuff)
	
		if count ~= oldCount then
			if (multi and not(test)) or (test and MultiChecked)then
				if not(multiShown) then
					me.PCBkgnd:Show()
					me.GCBkgnd:Show()
					me.SCBkgnd:Show()
					
					me.PCText:Show()
					me.GCText:Show()
					me.SCText:Show()
				
					multiShown = true
				end
				me.PCText:SetText(string.format("%i PARTY", party))
				me.GCText:SetText(string.format("%i GUILD", guild))
				me.SCText:SetText(string.format("%i SAY", say))
			elseif multiShown then
				me.PCBkgnd:Hide()
				me.GCBkgnd:Hide()
				me.SCBkgnd:Hide()
			
				me.PCText:Hide()
				me.GCText:Hide()
				me.SCText:Hide()
			
				multiShown = false
			end
		
			if count > 1 and multi and not(multiBorder) then -- More than one person to grat
				me:SetBackdrop( Backdrop2 )
				me.TitleRegion:SetBackdrop(TitleRegionBackdrop2)
				me.PCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Header")
				me.GCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Header")
				me.SCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Header")
				multiBorder = true
		
			elseif multiBorder then
				me:SetBackdrop( Backdrop1 ) 
				me.TitleRegion:SetBackdrop(TitleRegionBackdrop1)
				me.PCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
				me.GCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
				me.SCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
				multiBorder = false
			end
		
			if test then 
				GratButtonText = "Grat Test"
			elseif say > 0 and guild == 0 and party == 0 then
				GratButtonText = "Say Grats"
			elseif say == 0 and guild > 0 and party == 0 then
				GratButtonText = "Guild Grats"
			elseif say == 0 and guild == 0 and party > 0 then
				GratButtonText = "Party Grats"
			else
				GratButtonText = "Mixed Grats"
			end
		
			if not(test) and multi then
				GratButtonText = count .. " " .. GratButtonText
			end
		
			me.GratsButton:SetText(GratButtonText)
			oldCount = count
		end
	
		if (test and AutoFadeChecked) or (not(test) and AchSnd_Settings.AutoFade) then
			fdelay = (fdelay - e)
			if (fdelay <= 0 ) then 
				if MouseOver then
					me:SetAlpha( 1 )
				else
					me:SetAlpha( (test and AchSnd.panel.MinAlpha:GetValue() or AchSnd_Settings.MinAlpha ) / 100)
				end
				fdelay = 0
			else
				me:SetAlpha( 1)
			end
		else
			me:SetAlpha( 1)
		end

		if (test and MsgBoxTimeout ~= 0) or (not(test) and AchSnd.MsgBoxTimeout ~= 0) then
			if not( MouseOver ) then -- pauses countdown when mouse over
				cdown = (cdown - e)
			end
			
			if (cdown > 0) then
				me.CancelButton:SetText( string.format("Cancel ( %i )", math.ceil(cdown)))
			elseif (cdown <= 0) then
				-- Countdown timeout
				me:Hide()
				if test then
					InterfaceOptionsFrame:Show()
					AchSnd.MBox.Test = false
				end
				AchSnd.MBox.last = ""
				TextFrame:Clear()
				wipe(AchSnd.MBox.Mode.guild)
				wipe(AchSnd.MBox.Mode.party)
				wipe(AchSnd.MBox.Mode.say)
			end
		end
	
		e=0
	end)

end
	
-- Title region
me.TitleRegion = CreateFrame("Frame", nil, me)
me.TitleRegion:SetPoint( "CENTER", me, "TOP" , 0, -8)
me.TitleRegion:SetFrameStrata('DIALOG')
me.TitleRegion:SetToplevel(true)
me.TitleRegion:EnableMouse(true)
me.TitleRegion:SetMovable(true)
me.TitleRegion:RegisterForDrag("LeftButton") --, "RightButton") right button if ever resizeable
me.TitleRegion:SetClampedToScreen(true)		
me.TitleRegion:SetBackdrop(	TitleRegionBackdrop1 )
me.TitleRegion:SetScript('OnDragStart', function(self, button)
	if not(self.parent) then
		self.parent = self:GetParent()
	end
	if button == "LeftButton" then
		self.parent:StartMoving()
		self.isMoving = true
		self.hasMoved = false
	elseif button == "RightButton" then
		self.parent:StartSizing()
		self.isMoving = true
		self.hasMoved = false
	end
end)

me.TitleRegion:SetScript('OnDragStop', function(self)
	if ( self.isMoving ) then
        self.parent:StopMovingOrSizing();
        self.isMoving = false;
        self.hasMoved = true;
    end
end)


-- Title frame text
me.Title = me.TitleRegion:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
me.Title:SetText("Achievement Sounds")
me.Title:SetPoint( "CENTER", me.TitleRegion, "CENTER", 0, 0)
me.Title:SetJustifyH( "CENTER" )
me.Title:SetJustifyV( "MIDDLE" )

me.TitleRegion:SetWidth(me.Title:GetStringWidth() + 16)
me.TitleRegion:SetHeight(me.Title:GetStringHeight() + 16)

-- Grat Button
me.GratsButton = CreateFrame( "Button", "AchSndMsgBoxGratButton", me, "UIPanelButtonTemplate" )
me.GratsButton:SetPoint("CENTER", me, "BOTTOM", -85, 25)
me.GratsButton:SetSize( 150, 25)
me.GratsButton:SetScript("OnClick", function(self, button, down)
	if button ~= "LeftButton" then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	me:Hide()
	TextFrame:Clear()
	-- Testing the frame
	if AchSnd.MBox.Test then
		InterfaceOptionsFrame:Show()
		return
	end
	
	-- Set Alert Box Position
	if not(AchSnd_SettingsPC.AlertPosSet) then
		AchSnd_SettingsPC.AlertPosSet = true
		return
	end
	
	-- grats stuff goes here
	if AchSnd_Settings.Random then
		AchSnd.RandMsg()
	else
		AchSnd.DefMsg()
	end
end)

-- Cancel Button
me.CancelButton = CreateFrame( "Button", "AchSndMsgBoxCancelButton", me, "UIPanelButtonTemplate" )
me.CancelButton:SetPoint("CENTER", me, "BOTTOM", 85, 25)
me.CancelButton:SetSize( 150, 25)
me.CancelButton:SetText("Cancel")
me.CancelButton:SetScript("OnClick", function(self, button, down)
	if button ~= "LeftButton" then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	me:Hide()
	TextFrame:Clear()
	
	-- Testing the frame
	if AchSnd.MBox.Test then
		InterfaceOptionsFrame:Show()
		return
	end

	-- Set Alert Box position
	if not(AchSnd_SettingsPC.AlertPosSet) then
		AchSnd_SettingsPC.AlertPosSet = true
		return
	end
	-- cancel stuff goes here
	wipe(AchSnd.MBox.Mode.guild)
	wipe(AchSnd.MBox.Mode.party)
	wipe(AchSnd.MBox.Mode.say)
end)


local xmove = 58
local ymove = 14
local width = 250

-- Party count bkgnd
	me.PCBkgnd=me:CreateTexture(nil , "ARTWORK")
	me.PCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	me.PCBkgnd:SetSize( width, 64)
	me.PCBkgnd:SetPoint( "TOPLEFT", me, "BOTTOMLEFT", -xmove, ymove)

-- Party count
	me.PCText = me:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
	me.PCText:SetText(string.format("%i PARTY", #AchSnd.MBox.Mode.party))
	me.PCText:SetPoint( "CENTER", me.PCBkgnd, "CENTER",0, 12 )
	me.PCText:SetJustifyH( "CENTER" )
	me.PCText:SetJustifyV( "MIDDLE" )

-- Guild count bkgnd
	me.GCBkgnd=me:CreateTexture(nil , "ARTWORK")
	me.GCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	me.GCBkgnd:SetSize( width, 64)
	me.GCBkgnd:SetPoint( "TOP", me, "BOTTOM", 0, ymove)

-- Guild count
	me.GCText = me:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
	me.GCText:SetText(string.format("%i GUILD", #AchSnd.MBox.Mode.guild))
	me.GCText:SetPoint( "CENTER", me.GCBkgnd, "CENTER", 0, 12 )
	me.GCText:SetJustifyH( "CENTER" )
	me.GCText:SetJustifyV( "MIDDLE" )

-- Say count bkgnd
	me.SCBkgnd=me:CreateTexture(nil , "ARTWORK")
	me.SCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	me.SCBkgnd:SetSize( width, 64)
	me.SCBkgnd:SetPoint( "TOPRIGHT", me, "BOTTOMRIGHT", xmove, ymove)

-- Say count
	me.SCText = me:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
	me.SCText:SetText(string.format("%i SAY", #AchSnd.MBox.Mode.say))
	me.SCText:SetPoint( "CENTER", me.SCBkgnd, "CENTER", 0, 12 )
	me.SCText:SetJustifyH( "CENTER" )
	me.SCText:SetJustifyV( "MIDDLE" )
	
